Index: issm/trunk/src/c/classes/Inputs/PentaInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/PentaInput.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/PentaInput.cpp	(revision 18301)
@@ -13,28 +13,28 @@
 
 /*PentaInput constructors and destructor*/
-/*FUNCTION PentaInput::PentaInput(){{{*/
-PentaInput::PentaInput(){
+PentaInput::PentaInput(){/*{{{*/
 	values = NULL;
 }
 /*}}}*/
-/*FUNCTION PentaInput::PentaInput(int in_enum_type,IssmDouble* values,int element_type){{{*/
-PentaInput::PentaInput(int in_enum_type,IssmDouble* in_values,int element_type_in)
-		:PentaRef(1)
-{
-
-	/*Set PentaRef*/
-	this->SetElementType(element_type_in,0);
-	this->element_type=element_type_in;
+PentaInput::PentaInput(int in_enum_type,IssmDouble* in_values,int interpolation_type_in){/*{{{*/
 
 	/*Set Enum*/
-	enum_type=in_enum_type;
+	this->enum_type=in_enum_type;
+	this->interpolation_type=interpolation_type_in;
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Set values*/
-	this->values=xNew<IssmDouble>(this->NumberofNodes());
-	for(int i=0;i<this->NumberofNodes();i++) values[i]=in_values[i];
-}
-/*}}}*/
-/*FUNCTION PentaInput::~PentaInput(){{{*/
-PentaInput::~PentaInput(){
+	if (numnodes > 0){
+		this->values=xNew<IssmDouble>((unsigned int)numnodes);
+		for(int i=0;i<this->NumberofNodes(this->interpolation_type);i++) values[i]=in_values[i];
+	}
+	else{
+		this->values = NULL;
+	}
+
+}
+/*}}}*/
+PentaInput::~PentaInput(){/*{{{*/
 	xDelete<IssmDouble>(this->values);
 }
@@ -42,22 +42,18 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION PentaInput::Echo {{{*/
-void PentaInput::Echo(void){
+void PentaInput::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION PentaInput::DeepEcho{{{*/
-void PentaInput::DeepEcho(void){
+void PentaInput::DeepEcho(void){/*{{{*/
 
 	_printf_(setw(15)<<"   PentaInput "<<setw(25)<<left<<EnumToStringx(this->enum_type)<<" [");
-	for(int i=0;i<this->NumberofNodes();i++) _printf_(" "<<this->values[i]);
+	for(int i=0;i<this->NumberofNodes(this->interpolation_type);i++) _printf_(" "<<this->values[i]);
 	_printf_("]\n");
 }
 /*}}}*/
-/*FUNCTION PentaInput::Id{{{*/
-int    PentaInput::Id(void){ return -1; }
-/*}}}*/
-/*FUNCTION PentaInput::ObjectEnum{{{*/
-int PentaInput::ObjectEnum(void){
+int    PentaInput::Id(void){ return -1; }/*{{{*/
+/*}}}*/
+int PentaInput::ObjectEnum(void){/*{{{*/
 
 	return PentaInputEnum;
@@ -65,8 +61,7 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::copy{{{*/
-Object* PentaInput::copy() {
-
-	return new PentaInput(this->enum_type,this->values,this->element_type);
+Object* PentaInput::copy() {/*{{{*/
+
+	return new PentaInput(this->enum_type,this->values,this->interpolation_type);
 
 }
@@ -74,6 +69,5 @@
 
 /*PentaInput management*/
-/*FUNCTION PentaInput::InstanceEnum{{{*/
-int PentaInput::InstanceEnum(void){
+int PentaInput::InstanceEnum(void){/*{{{*/
 
 	return this->enum_type;
@@ -81,11 +75,10 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::SpawnTriaInput{{{*/
-Input* PentaInput::SpawnTriaInput(int index1,int index2,int index3){
+Input* PentaInput::SpawnTriaInput(int index1,int index2,int index3){/*{{{*/
 
 	/*output*/
 	TriaInput* outinput=NULL;
 
-	if(this->element_type==P0Enum){ 
+	if(this->interpolation_type==P0Enum){ 
 		outinput=new TriaInput(this->enum_type,&this->values[0],P0Enum);
 	}
@@ -112,28 +105,27 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::SpawnSegInput{{{*/
-Input* PentaInput::SpawnSegInput(int index1,int index2){
+Input* PentaInput::SpawnSegInput(int index1,int index2){/*{{{*/
 
 	_error_("not supported");
 }
 /*}}}*/
-/*FUNCTION PentaInput::GetResultInterpolation{{{*/
-int  PentaInput::GetResultInterpolation(void){
-
+int  PentaInput::GetResultInterpolation(void){/*{{{*/
+
+	if(this->interpolation_type==P0Enum){
+		return P0Enum;
+	}
 	return P1Enum;
 
 }
 /*}}}*/
-/*FUNCTION PentaInput::GetResultNumberOfNodes{{{*/
-int  PentaInput::GetResultNumberOfNodes(void){
-
-	return this->NumberofNodes();;
-
-}
-/*}}}*/
-/*FUNCTION PentaInput::ResultToPatch{{{*/
-void PentaInput::ResultToPatch(IssmDouble* values,int nodesperelement,int sid){
-
-	int numnodes = this->NumberofNodes();
+int  PentaInput::GetResultNumberOfNodes(void){/*{{{*/
+
+	return this->NumberofNodes(this->interpolation_type);;
+
+}
+/*}}}*/
+void PentaInput::ResultToPatch(IssmDouble* values,int nodesperelement,int sid){/*{{{*/
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Some checks*/
@@ -147,8 +139,7 @@
 
 /*Object functions*/
-/*FUNCTION PentaInput::GetInputValue(IssmDouble* pvalue){{{*/
-void PentaInput::GetInputValue(IssmDouble* pvalue){
-
-	if(this->element_type==P0Enum){
+void PentaInput::GetInputValue(IssmDouble* pvalue){/*{{{*/
+
+	if(this->interpolation_type==P0Enum){
 		pvalue=&values[0];
 	}
@@ -156,30 +147,26 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){{{*/
-void PentaInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){
+void PentaInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){/*{{{*/
 
 	/*Call PentaRef function*/
 	_assert_(gauss->Enum()==GaussPentaEnum);
-	PentaRef::GetInputValue(pvalue,&values[0],(GaussPenta*)gauss);
-
-}
-/*}}}*/
-/*FUNCTION PentaInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){{{*/
-void PentaInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list,Gauss* gauss){
+	PentaRef::GetInputValue(pvalue,&values[0],(GaussPenta*)gauss,this->interpolation_type);
+
+}
+/*}}}*/
+void PentaInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
 
 	/*Call PentaRef function*/
 	_assert_(gauss->Enum()==GaussPentaEnum);
-	PentaRef::GetInputDerivativeValue(p,&values[0],xyz_list,(GaussPenta*)gauss);
-}
-/*}}}*/
-/*FUNCTION PentaInput::ChangeEnum{{{*/
-void PentaInput::ChangeEnum(int newenumtype){
+	PentaRef::GetInputDerivativeValue(p,&values[0],xyz_list,(GaussPenta*)gauss,this->interpolation_type);
+}
+/*}}}*/
+void PentaInput::ChangeEnum(int newenumtype){/*{{{*/
 	this->enum_type=newenumtype;
 }
 /*}}}*/
-/*FUNCTION PentaInput::GetInputAverage{{{*/
-void PentaInput::GetInputAverage(IssmDouble* pvalue){
-
-	int        numnodes  = this->NumberofNodes();
+void PentaInput::GetInputAverage(IssmDouble* pvalue){/*{{{*/
+
+	int        numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble numnodesd = reCast<int,IssmDouble>(numnodes);
 	IssmDouble value     = 0.;
@@ -193,8 +180,7 @@
 
 /*Intermediary*/
-/*FUNCTION PentaInput::SquareMin{{{*/
-void PentaInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){
-
-	int        numnodes=this->NumberofNodes();
+void PentaInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){/*{{{*/
+
+	int        numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble squaremin;
 
@@ -208,17 +194,15 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::ConstrainMin{{{*/
-void PentaInput::ConstrainMin(IssmDouble minimum){
-
-	int numnodes = this->NumberofNodes();
+void PentaInput::ConstrainMin(IssmDouble minimum){/*{{{*/
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 	for(int i=0;i<numnodes;i++) if (values[i]<minimum) values[i]=minimum;
 }
 /*}}}*/
-/*FUNCTION PentaInput::InfinityNorm{{{*/
-IssmDouble PentaInput::InfinityNorm(void){
+IssmDouble PentaInput::InfinityNorm(void){/*{{{*/
 
 	/*Output*/
 	IssmDouble norm=0.;
-	int numnodes=this->NumberofNodes();
+	int numnodes=this->NumberofNodes(this->interpolation_type);
 
 	for(int i=0;i<numnodes;i++) if(fabs(values[i])>norm) norm=fabs(values[i]);
@@ -226,8 +210,7 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::Max{{{*/
-IssmDouble PentaInput::Max(void){
-
-	int  numnodes=this->NumberofNodes();
+IssmDouble PentaInput::Max(void){/*{{{*/
+
+	int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble max=values[0];
 
@@ -238,8 +221,7 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::MaxAbs{{{*/
-IssmDouble PentaInput::MaxAbs(void){
-
-	int  numnodes=this->NumberofNodes();
+IssmDouble PentaInput::MaxAbs(void){/*{{{*/
+
+	int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble max=fabs(values[0]);
 
@@ -250,8 +232,7 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::Min{{{*/
-IssmDouble PentaInput::Min(void){
-
-	const int  numnodes=this->NumberofNodes();
+IssmDouble PentaInput::Min(void){/*{{{*/
+
+	const int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble min=values[0];
 
@@ -262,8 +243,7 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::MinAbs{{{*/
-IssmDouble PentaInput::MinAbs(void){
-
-	const int  numnodes=this->NumberofNodes();
+IssmDouble PentaInput::MinAbs(void){/*{{{*/
+
+	const int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble min=fabs(values[0]);
 
@@ -274,15 +254,13 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::Scale{{{*/
-void PentaInput::Scale(IssmDouble scale_factor){
-
-	const int numnodes=this->NumberofNodes();
+void PentaInput::Scale(IssmDouble scale_factor){/*{{{*/
+
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 	for(int i=0;i<numnodes;i++)values[i]=values[i]*scale_factor;
 }
 /*}}}*/
-/*FUNCTION PentaInput::AXPY{{{*/
-void PentaInput::AXPY(Input* xinput,IssmDouble scalar){
-
-	const int numnodes=this->NumberofNodes();
+void PentaInput::AXPY(Input* xinput,IssmDouble scalar){/*{{{*/
+
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 	PentaInput* xpentainput=NULL;
 
@@ -296,5 +274,5 @@
 	  _error_("Operation not permitted because xinput is of type " << EnumToStringx(xinput->ObjectEnum()));
 	xpentainput=(PentaInput*)xinput;
-	if(xpentainput->element_type!=this->element_type) _error_("Operation not permitted because xinput is of type " << EnumToStringx(xpentainput->element_type));
+	if(xpentainput->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because xinput is of type " << EnumToStringx(xpentainput->interpolation_type));
 
 	/*Carry out the AXPY operation depending on type:*/
@@ -303,9 +281,8 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::Constrain{{{*/
-void PentaInput::Constrain(IssmDouble cm_min, IssmDouble cm_max){
+void PentaInput::Constrain(IssmDouble cm_min, IssmDouble cm_max){/*{{{*/
 
 	int i;
-	const int numnodes=this->NumberofNodes();
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 
 	if(!xIsNan<IssmDouble>(cm_min)) for(i=0;i<numnodes;i++)if (this->values[i]<cm_min)this->values[i]=cm_min;
@@ -314,18 +291,16 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::Extrude{{{*/
-void PentaInput::Extrude(void){
-
-	switch(this->element_type){
+void PentaInput::Extrude(void){/*{{{*/
+
+	switch(this->interpolation_type){
 		case P1Enum:
 			for(int i=0;i<3;i++) this->values[3+i]=this->values[i];
 			break;
 		default:
-			_error_("not supported yet for type "<<EnumToStringx(this->element_type));
-	}
-}
-/*}}}*/
-/*FUNCTION PentaInput::VerticallyIntegrate{{{*/
-void PentaInput::VerticallyIntegrate(Input* thickness_input){
+			_error_("not supported yet for type "<<EnumToStringx(this->interpolation_type));
+	}
+}
+/*}}}*/
+void PentaInput::VerticallyIntegrate(Input* thickness_input){/*{{{*/
 
 	IssmDouble thickness;
@@ -336,10 +311,10 @@
 
 	/*vertically integrate depending on type (and use P1 interpolation from now on)*/
-	switch(this->element_type){
+	switch(this->interpolation_type){
 		case P1Enum:
 		case P1bubbleEnum:
 		case P2Enum:
 			  {
-				this->element_type=P1Enum;
+				this->interpolation_type=P1Enum;
 				GaussPenta *gauss=new GaussPenta();
 				for(int iv=0;iv<3;iv++){
@@ -353,10 +328,9 @@
 			  }
 		default:
-			_error_("not supported yet for type "<<EnumToStringx(this->element_type));
-	}
-}
-/*}}}*/
-/*FUNCTION PentaInput::PointwiseDivide{{{*/
-Input* PentaInput::PointwiseDivide(Input* inputB){
+			_error_("not supported yet for type "<<EnumToStringx(this->interpolation_type));
+	}
+}
+/*}}}*/
+Input* PentaInput::PointwiseDivide(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -365,10 +339,10 @@
 	/*Intermediaries*/
 	PentaInput *xinputB  = NULL;
-	const int   numnodes = this->NumberofNodes();
+	const int   numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Check that inputB is of the same type*/
 	if(inputB->ObjectEnum()!=PentaInputEnum)     _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(PentaInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Allocate intermediary*/
@@ -382,5 +356,5 @@
 
 	/*Create new Penta vertex input (copy of current input)*/
-	outinput=new PentaInput(this->enum_type,AdotBvalues,this->element_type);
+	outinput=new PentaInput(this->enum_type,AdotBvalues,this->interpolation_type);
 
 	/*Return output pointer*/
@@ -390,6 +364,5 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::PointwiseMin{{{*/
-Input* PentaInput::PointwiseMin(Input* inputB){
+Input* PentaInput::PointwiseMin(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -399,5 +372,5 @@
 	int         i;
 	PentaInput  *xinputB   = NULL;
-	const int   numnodes  = this->NumberofNodes();
+	const int   numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble *minvalues = xNew<IssmDouble>(numnodes);
 
@@ -405,5 +378,5 @@
 	if(inputB->ObjectEnum()!=PentaInputEnum)       _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(PentaInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Create point wise min*/
@@ -414,5 +387,5 @@
 
 	/*Create new Penta vertex input (copy of current input)*/
-	outinput=new PentaInput(this->enum_type,&minvalues[0],this->element_type);
+	outinput=new PentaInput(this->enum_type,&minvalues[0],this->interpolation_type);
 
 	/*Return output pointer*/
@@ -421,6 +394,5 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::PointwiseMax{{{*/
-Input* PentaInput::PointwiseMax(Input* inputB){
+Input* PentaInput::PointwiseMax(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -430,5 +402,5 @@
 	int         i;
 	PentaInput  *xinputB   = NULL;
-	const int   numnodes  = this->NumberofNodes();
+	const int   numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble *maxvalues = xNew<IssmDouble>(numnodes);
 
@@ -436,5 +408,5 @@
 	if(inputB->ObjectEnum()!=PentaInputEnum) _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(PentaInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Create point wise max*/
@@ -445,5 +417,5 @@
 
 	/*Create new Penta vertex input (copy of current input)*/
-	outinput=new PentaInput(this->enum_type,&maxvalues[0],this->element_type);
+	outinput=new PentaInput(this->enum_type,&maxvalues[0],this->interpolation_type);
 
 	/*Return output pointer*/
@@ -452,11 +424,9 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::GetVectorFromInputs{{{*/
-void PentaInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){
+void PentaInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){/*{{{*/
 	const int numvertices=6;
 	vector->SetValues(numvertices,doflist,this->values,INS_VAL);
 } /*}}}*/
-/*FUNCTION PentaInput::Configure{{{*/
-void PentaInput::Configure(Parameters* parameters){
+void PentaInput::Configure(Parameters* parameters){/*{{{*/
 	/*do nothing: */
 }
Index: issm/trunk/src/c/classes/Inputs/PentaInput.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/PentaInput.h	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/PentaInput.h	(revision 18301)
@@ -17,5 +17,6 @@
 
 	public:
-		int        enum_type;
+		int         enum_type;
+		int         interpolation_type;
 		IssmDouble* values;
 
Index: issm/trunk/src/c/classes/Inputs/SegInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/SegInput.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/SegInput.cpp	(revision 18301)
@@ -13,28 +13,20 @@
 
 /*SegInput constructors and destructor*/
-/*FUNCTION SegInput::SegInput(){{{*/
-SegInput::SegInput(){
+SegInput::SegInput(){/*{{{*/
 	values = NULL;
 }
 /*}}}*/
-/*FUNCTION SegInput::SegInput(int in_enum_type,IssmDouble* invalues,element_type_in){{{*/
-SegInput::SegInput(int in_enum_type,IssmDouble* in_values,int element_type_in)
-	:SegRef(1)
-{
-
-	/*Set SegRef*/
-	this->SetElementType(element_type_in,0);
-	this->element_type=element_type_in;
+SegInput::SegInput(int in_enum_type,IssmDouble* in_values,int interpolation_type_in){/*{{{*/
 
 	/*Set Enum*/
 	enum_type=in_enum_type;
+	this->interpolation_type=interpolation_type_in;
 
 	/*Set values*/
-	this->values=xNew<IssmDouble>(this->NumberofNodes());
-	for(int i=0;i<this->NumberofNodes();i++) values[i]=in_values[i];
+	this->values=xNew<IssmDouble>(this->NumberofNodes(this->interpolation_type));
+	for(int i=0;i<this->NumberofNodes(this->interpolation_type);i++) values[i]=in_values[i];
 }
 /*}}}*/
-/*FUNCTION SegInput::~SegInput(){{{*/
-SegInput::~SegInput(){
+SegInput::~SegInput(){/*{{{*/
 	xDelete<IssmDouble>(this->values);
 }
@@ -42,22 +34,18 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION SegInput::Echo {{{*/
-void SegInput::Echo(void){
+void SegInput::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION SegInput::DeepEcho{{{*/
-void SegInput::DeepEcho(void){
+void SegInput::DeepEcho(void){/*{{{*/
 
 	_printf_(setw(15)<<"   SegInput "<<setw(25)<<left<<EnumToStringx(this->enum_type)<<" [");
-	for(int i=0;i<this->NumberofNodes();i++) _printf_(" "<<this->values[i]);
+	for(int i=0;i<this->NumberofNodes(this->interpolation_type);i++) _printf_(" "<<this->values[i]);
 	_printf_("]\n");
 }
 /*}}}*/
-/*FUNCTION SegInput::Id{{{*/
-int    SegInput::Id(void){ return -1; }
+int    SegInput::Id(void){ return -1; }/*{{{*/
 /*}}}*/
-/*FUNCTION SegInput::ObjectEnum{{{*/
-int SegInput::ObjectEnum(void){
+int SegInput::ObjectEnum(void){/*{{{*/
 
 	return SegInputEnum;
@@ -65,8 +53,7 @@
 }
 /*}}}*/
-/*FUNCTION SegInput::copy{{{*/
-Object* SegInput::copy() {
+Object* SegInput::copy() {/*{{{*/
 
-	return new SegInput(this->enum_type,this->values,this->element_type);
+	return new SegInput(this->enum_type,this->values,this->interpolation_type);
 
 }
@@ -74,6 +61,5 @@
 
 /*SegInput management*/
-/*FUNCTION SegInput::InstanceEnum{{{*/
-int SegInput::InstanceEnum(void){
+int SegInput::InstanceEnum(void){/*{{{*/
 
 	return this->enum_type;
@@ -83,8 +69,7 @@
 
 /*Object functions*/
-/*FUNCTION SegInput::GetInputAverage{{{*/
-void SegInput::GetInputAverage(IssmDouble* pvalue){
+void SegInput::GetInputAverage(IssmDouble* pvalue){/*{{{*/
 
-	int        numnodes  = this->NumberofNodes();
+	int        numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble numnodesd = reCast<int,IssmDouble>(numnodes);
 	IssmDouble value     = 0.;
@@ -96,30 +81,26 @@
 }
 /*}}}*/
-/*FUNCTION SegInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){{{*/
-void SegInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){
+void SegInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){/*{{{*/
 
 	/*Call SegRef function*/
 	_assert_(gauss->Enum()==GaussSegEnum);
-	SegRef::GetInputValue(pvalue,&values[0],(GaussSeg*)gauss);
+	SegRef::GetInputValue(pvalue,&values[0],(GaussSeg*)gauss,this->interpolation_type);
 
 }
 /*}}}*/
-/*FUNCTION SegInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){{{*/
-void SegInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list,Gauss* gauss){
+void SegInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
 
 	/*Call SegRef function*/
 	_assert_(gauss->Enum()==GaussSegEnum);
-	SegRef::GetInputDerivativeValue(p,&values[0],xyz_list,(GaussSeg*)gauss);
+	SegRef::GetInputDerivativeValue(p,&values[0],xyz_list,(GaussSeg*)gauss,this->interpolation_type);
 }
 /*}}}*/
-/*FUNCTION SegInput::Configure{{{*/
-void SegInput::Configure(Parameters* parameters){
+void SegInput::Configure(Parameters* parameters){/*{{{*/
 	/*do nothing: */
 }
 /*}}}*/
-/*FUNCTION SegInput::Min{{{*/
-IssmDouble SegInput::Min(void){
+IssmDouble SegInput::Min(void){/*{{{*/
 
-	const int  numnodes=this->NumberofNodes();
+	const int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble min=values[0];
 
Index: issm/trunk/src/c/classes/Inputs/SegInput.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/SegInput.h	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/SegInput.h	(revision 18301)
@@ -18,4 +18,5 @@
 	public:
 		int         enum_type;
+		int         interpolation_type;
 		IssmDouble* values;
 
